routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/welcome', function () {
    return view('welcome');
})->name('welcome');

Route::get('/', [App\Http\Controllers\HomeController::class, 'index']);

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::get('/home', 'App\Http\Controllers\HomeController@index')->name('home')->middleware('auth:employe');

Route::group(['middleware' => 'auth:employe'], function () {
    Auth::routes();

    Route::get('vehicule', [App\Http\Controllers\VehiculeController::class, 'index'], function () {
        return view('vehicules.index');
    })->name('vehicule');

    Route::get('vehicule/search', 'App\Http\Controllers\VehiculeController@indexFiltering')->name('searchv');

	Route::get('contrat', [App\Http\livewire\Contrats::class, 'render'], function () {
		return view('contrats.render');
	})->name('contrat');

    Route::get('contrat/search', 'App\Http\livewire\Contrats@indexFiltering')->name('search');

    Route::get('mpaper', function () {
        return view('contrats.paper');
    });

    Route::get('client', [App\Http\livewire\clients::class, 'render'], function () {
        return view('clients.render');
    })->name('client');


    Route::resource('entreprises', 'App\Http\Controllers\EntrepriseController');
    Route::resource('admins', 'App\Http\Controllers\AdminController');
    Route::resource('employes', 'App\Http\Controllers\EmployeController');
    Route::resource('clients', 'App\Http\Controllers\ClientController');
    Route::resource('conducteurs', 'App\Http\Controllers\ConducteurController');
    Route::resource('vehicules', 'App\Http\Controllers\VehiculeController');
    Route::resource('photos', 'App\Http\Controllers\PhotoController');
    Route::resource('contrats', 'App\Http\livewire\Contrats');
    Route::resource('designunits', 'App\Http\Controllers\DesignunitController');
    Route::resource('designmontants', 'App\Http\Controllers\DesignmontantController');
    Route::resource('montants', 'App\Http\Controllers\MontantController');
    Route::resource('checkouts', 'App\Http\Controllers\CheckoutController');
    Route::resource('rapports', 'App\Http\Controllers\RapportController');


    Route::get('/contrats/{contrat}/{vehicule}/{client}', 'App\Http\Controllers\ContratController@show')->name('contrats.showa');
    Route::get('/edit/contrats/{contrat}/{vehicule}/{client}', 'App\Http\Controllers\ContratController@edit')->name('contrats.edita');

    Route::get('/contrats/print/{contrat}', 'App\Http\livewire\Contrats@print')->name('contrats.print');

    Route::get('/contrats/printpdf/{contrat}', 'App\Http\livewire\Contrats@printpdf')->name('contrats.printpdf');

    Route::get('/disponibilite/update', 'App\Http\Controllers\VehiculeController@updateDisponibilite')->name('vehicules.update.disponibilite');
    Route::get('/climatisation/update', 'App\Http\Controllers\VehiculeController@updateClimatisation')->name('vehicules.update.climatisation');
});

Route::group(['middleware' => 'auth:employe'], function () {
    Auth::routes();
    Route::resource('user', 'App\Http\Controllers\UserController', ['except' => ['show']]);
    Route::get('profile', ['as' => 'profile.edit', 'uses' => 'App\Http\Controllers\ProfileController@edit']);
    Route::put('profile', ['as' => 'profile.update', 'uses' => 'App\Http\Controllers\ProfileController@update']);
    Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'App\Http\Controllers\ProfileController@password']);
});

Auth::routes();

Route::get('/login/admin', 'App\Http\Controllers\Auth\LoginController@showAdminLoginForm');
Route::get('/login/employe', 'App\Http\Controllers\Auth\LoginController@showEmployeLoginForm');

Route::post('/login/admin', 'App\Http\Controllers\Auth\LoginController@adminLogin');
Route::post('/login/employe', 'App\Http\Controllers\Auth\LoginController@employeLogin');

Route::get('loginadmin', function () {
    return view('auth.loginadmin');
})->name('loginadmin');

Route::post('/save', [
    'uses' => 'App\Http\Controllers\VehiculeController@store',
    'as' => 'vehicules',
]);

app/Http/Livewire/Clients.php
<?php

namespace App\Http\Livewire;

use App\Models\Client;
use Livewire\Component;

class Clients extends Component
{
    public function render()
    {
        return view('clients.clients', ['clients' => Client::latest()->paginate(4)]);
    }
}

app/Http/Livewire/Contrats.php
<?php

namespace App\Http\Livewire;

use App\Http\Controllers\ContratController;
use App\Models\Checkout;
use App\Models\Client;
use App\Models\Conducteur;
use App\Models\Contrat;
use App\Models\Designmontant;
use App\Models\Designunit;
use App\Models\Entreprise;
use App\Models\Montant;
use App\Models\Vehicule;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Livewire\Component;
use Meneses\LaravelMpdf\Facades\LaravelMpdf as PDf;

class Contrats extends Component
{
    public $contrats, $client_id, $vehicule_matricule,
        $livraison, $reprise,
        $dateDebut, $dateFin,
        $carburationD, $carburationR,
        $kmD, $kmR, $nbrJour, $prolongation,
        $contrat_id;

    public $client = '\App\Http\Livewire\Contrats::findClient';
    public $vehicule = '\App\Http\Livewire\Contrats::findVehicule';
    public $montant = '\App\Http\Livewire\Contrats::getMontant';
    public $designu = '\App\Http\Livewire\Contrats::getDesignUnit';
    public $designm = '\App\Http\Livewire\Contrats::getDesignMontant';
    public $conducteur = '\App\Http\Livewire\Contrats::getConducteur';
    public $checkOut = '\App\Http\Livewire\Contrats::getCheckOut';

    public $updateMode = false;
    public $search = '';

    public function __construct()
    {
        $this->contrats = Contrat::latest()->paginate(4);
    }

    public function render()
    {
        //Log::error("message: ". $this->search);
        $this->contrats = Contrat::latest()->paginate(4);
        //$search = '%'.$this->search.'%';

        return view('Livewire.index', [
            //'contrats' => $this->contrats,
            'client' => $this->client,
            'montant' => $this->montant,
            //'contrats' => $this->contrats,
            'search' => $this->search,


            'contrats' => Contrat::whereLike('vehicule_matricule', $this->search ?? '')->latest()->paginate(4),
        ]);
    }

    public function indexFiltering(Request $request)
    {
        $this->search = $request->query('search');
        info('search func.');
        $this->contrats = Contrat::whereLike('vehicule_matricule', $this->search ?? '')->paginate(4);

        return view('Livewire.index', ['client' => $this->client,
        'montant' => $this->montant,])->with('contrats', $this->contrats)->with('search', $this->search);
    }

    public function show(Contrat $contrat)
    {
        //$ident = Auth::employe();
        $idEntreprise = Auth::guard('employe')->user()->entreprise_id;
        $cemploye = Auth::guard('employe')->user();
        $entreprise = $this->getEntreprise($idEntreprise);
        return view('contrats.show', [
            'contrat' => $contrat,
            'client' => $this->client,
            'vehicule' => $this->vehicule,
            'entreprise' => $entreprise,
            'designu' => $this->designu,
            'designm' => $this->designm,
            'montant' => $this->montant,
            'conducteur' => $this->conducteur,
            'checkOut' => $this->checkOut,
            'cemploye' => $cemploye,
        ]);
    }

    public function print(Contrat $contrat)
    {
        $idEntreprise = Auth::guard('employe')->user()->entreprise_id;
        $cemploye = Auth::guard('employe')->user();
        $entreprise = $this->getEntreprise($idEntreprise);
        return view('contrats.printpaper', [
            'contrat' => $contrat,
            'client' => $this->client,
            'vehicule' => $this->vehicule,
            'entreprise' => $entreprise,
            'designu' => $this->designu,
            'designm' => $this->designm,
            'montant' => $this->montant,
            'conducteur' => $this->conducteur,
            'checkOut' => $this->checkOut,
            'cemploye' => $cemploye,
        ]);
    }

    public function printpdf(Contrat $contrat)
    {
        $idEntreprise = Auth::guard('employe')->user()->entreprise_id;
        $cemploye = Auth::guard('employe')->user();
        $entreprise = $this->getEntreprise($idEntreprise);
    }

    public function create()
    {
        $vehicules = Vehicule::all()->where('disponibilite', 1);
        //$clients = Client::all();
        return view('contrats.create', [
            'vehicules' => $vehicules,
            'fvehicule' => $this->vehicule,
            //'clients' => $clients,
        ]);
    }

    public function store(Request $request)
    {
        $contratController = new ContratController();
        $contratController->store($request);
        toast('Contrat cree avec success', 'success');
        return redirect()->to('/contrat');
    }

    public function edit(Contrat $contrat)
    {
        //dd($contrat->vehicule_matricule);
        $vehicules = Vehicule::all()->where('disponibilite', 1);
        $client = $this->findClient($contrat->client_id);
        $montant = $this->getMontant($contrat->id);
        $checkOut = $this->getCheckOut($contrat->id);
        $designUnit = $this->getDesignUnit($contrat->id);
        $designMontant = $this->getDesignMontant($contrat->id);
        $conducteur = $this->getConducteur($client->id);
        return view('contrats.edit', [
            'contrat' => $contrat,
            'vehicule' => $contrat->vehicule_matricule,
            'client' => $client,
            'vehicules' => $vehicules,
            'montant' => $montant,
            'checkOut' => $checkOut,
            'designUnit' => $designUnit,
            'designMontant' => $designMontant,
            'conducteur' => $conducteur,
        ]);
        //return view('contrats.edit', compact('contrat'));
    }

    public function update(Request $request, Contrat $contrat)
    {
        $client = $this->findClient($contrat->client_id);
        $montant = $this->getMontant($contrat->id);
        $checkOut = $this->getCheckOut($contrat->id);
        $designUnit = $this->getDesignUnit($contrat->id);
        $designMontant = $this->getDesignMontant($contrat->id);
        $conducteur = $this->getConducteur($client->id);
        $contratController = new ContratController();
        $contratController->update($request, $contrat, $checkOut, $designUnit, $designMontant, $montant, $client, $conducteur);

        //Alert::success('Contrat', 'modifier avec success');
        //Alert::toast('Toast Message', 'success');
        toast('Contrat modifier avec success', 'success');
        return redirect()->to('/contrat');
    }

    public function destroy(Contrat $contrat)
    {
        $contrat->delete();
        toast('Contrat supprimer avec success', 'info');
        return redirect()->to('/contrat');
    }

    static function findClient($client_id)
    {
        return Client::find($client_id);
    }

    static function findVehicule($vehicule_matricule)
    {
        return Vehicule::find($vehicule_matricule);
    }

    static function getEntreprise($idEntreprise)
    {
        return Entreprise::find($idEntreprise);
    }

    static function getConducteur($client_id)
    {
        return Conducteur::where('client_id', $client_id)->first();
    }

    static function getMontant($contrat_id)
    {
        return Montant::where('contrat_id', $contrat_id)->first();
    }

    static function getCheckOut($contrat_id)
    {
        return Checkout::where('contrat_id', $contrat_id)->first();
    }

    static function getDesignUnit($contrat_id)
    {
        return Designunit::where('contrat_id', $contrat_id)->first();
    }

    static function getDesignMontant($contrat_id)
    {
        return Designmontant::where('contrat_id', $contrat_id)->first();
    }
}

resources/views/livewire/contrats.blade.php
<div>
    {{-- If you look to others for fulfillment, you will never truly be fulfilled. --}}
</div>

resources/views/livewire/index.blade.php
@extends('layouts.app', ['activePage' => 'Contrats', 'titlePage' => __('Contrats')])

@section('content')
    <div class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header card-header-primary">
                            <div class="pull-left">
                                <h4 class="card-title">Liste des contrats</h4>
                                <form action="{{ route('search') }}" method="GET">
                                    <input style="border-radius: 5px; width: 180%; border-color: transparent; background-color: #ffffffe3" type="text" id="search" name="search"
                                        placeholder="Rechercher par matricule" value="{{ $search }}">
                                    <button style="display:none" type="submit" class="btn btn-default mb-2">search</button>
                                </form>
                            </div>
                            <div class="pull-right">
                                <a class="btn btn-secondary" href="{{ route('contrats.create') }}"> Nouveau contrat</a>
                            </div>
                        </div>
                        <div class="card-body">
                            <div>
                                @if (session()->has('message'))
                                    <div class="alert alert-success">
                                        {{ session('message') }}
                                    </div>
                                @endif
                            </div>
                            <div class="table-responsive">
                                <table class="table">
                                    <thead class="text-primary">
                                        <th> Matricule </th>
                                        <th> Client </th>
                                        <th> Nombre de jours </th>
                                        <th> Montant </th>
                                        <th> Actions </th>
                                    </thead>
                                    <tbody>
                                        @foreach ($contrats as $contrat)
                                            <tr>
                                                <td>
                                                    <a href="{{ route('vehicules.show', $contrat->vehicule_matricule) }}">
                                                        {{ $contrat->vehicule_matricule }}
                                                    </a>

                                                </td>
                                                <td>
                                                    <ul>
                                                        <li>
                                                            CIN: {{ $client($contrat->client_id)->cin }}
                                                        </li>
                                                        <li>
                                                            Nom complet: {{ $client($contrat->client_id)->nom }}
                                                            {{ $client($contrat->client_id)->prenom }}
                                                        </li>
                                                    </ul>

                                                </td>
                                                <td>
                                                    {{ $contrat->nbrJour }}
                                                </td>
                                                <td>
                                                    @if (!empty($montant($contrat->id)))
                                                        {{ $montant($contrat->id)->montantRecu }}
                                                    @endif

                                                </td>
                                                <td>
                                                    <form action="{{ route('contrats.destroy', $contrat) }}"
                                                        method="POST">
                                                        <a class="btn btn-info btn-fab btn-fab-mini btn-round"
                                                            href="{{ route('contrats.show', $contrat) }}">
                                                            <i class="material-icons">description</i>
                                                        </a>

                                                        <a class="btn btn-default btn-fab btn-fab-mini btn-round"
                                                            href="{{ route('contrats.print', $contrat) }}"
                                                            target="_blank">
                                                            <i class="material-icons">print</i>
                                                        </a>

                                                        <a class="btn btn-warning btn-fab btn-fab-mini btn-round"
                                                            href="{{ route('contrats.printpdf', $contrat) }}"
                                                            target="_blank">
                                                            <i class="material-icons">picture_as_pdf</i>
                                                        </a>

                                                        <a class="btn btn-success btn-fab btn-fab-mini btn-round"
                                                            href="{{ route('contrats.edit', $contrat) }}">
                                                            <i class="material-icons">edit</i>
                                                        </a>

                                                        @csrf
                                                        @method('DELETE')
                                                        <button type="submit"
                                                            class="btn btn-danger btn-fab btn-fab-mini btn-round show_confirm">
                                                            <i class="material-icons">delete</i>
                                                        </button>
                                                    </form>
                                                </td>

                                            </tr>

                                        @endforeach
                                    </tbody>
                                </table>
                                {{ $contrats->render('pagination::bootstrap-4') }}
                                <!-- simple-bootstrap-4 -->
                            </div>
                        </div>
                    </div>
                </div>


                <!--<div class="col-md-12">
                                        <div class="card card-plain">
                                            <div class="card-header card-header-primary">
                                                <h4 class="card-title mt-0"> Gerer Contrats </h4>
                                                <p class="card-category"> Cree, modifier, supprimer, détailler </p>
                                            </div>
                                            <div class="card-body">
                                                <div class="table-responsive">
                                                    <table class="table table-hover">
                                                        <thead class="">
                                                            <th> ID </th>
                                                            <th> Name </th>
                                                            <th> Country </th>
                                                            <th> City </th>
                                                            <th> Salary </th>
                                                        </thead>
                                                        <tbody>
                                                            <tr>
                                                                <td> 1 </td>
                                                                <td> Dakota Rice </td>
                                                                <td> Niger </td>
                                                                <td> Oud-Turnhout </td>
                                                                <td> $36,738 </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </div>
                                            </div>
                                        </div>
                                    </div>-->

            </div>
        </div>
    </div>

    @push('js')
        <script src="https://cdnjs.cloudflare.com/ajax/libs/sweetalert/2.1.0/sweetalert.min.js"></script>
        <script type="text/javascript">
            $('.show_confirm').click(function(event) {
                var form = $(this).closest("form");
                var name = $(this).data("name");
                event.preventDefault();
                new swal({
                        title: `Êtes-vous sûr de vouloir supprimer cette contrat?`,
                        text: "Si vous le supprimez, il disparaîtra pour toujours.",
                        icon: "error",
                        buttons: true,
                        dangerMode: true,
                    })
                    .then((willDelete) => {
                        if (willDelete) {
                            form.submit();
                        }
                    });
            });
        </script>
    @endpush

@endsection